/*
 * Coloring interface in graffit library < coloring.h >
 *
 * Various Definitions of Color for Borland Graphics Interface
 *
 * Copyright (C) 1992-1994 Taiji Yamada, Tokyo Denki University
 * Copyright (C) 2000 Taiji Yamada, AIHARA Electrical Engineering Co., Ltd.
 */
#ifndef _COLORING_H_
#define _COLORING_H_
#include <graphics.h>

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
   顼(Coloring)ѥå

   BGIͿƤѥåȤФơǡ󥫥顼ʤɤ
   뤿Υ롼󽸤Ǥ㤨4եå褹ˡ
   4ܤ򥰥ǡ󥫥顼˳Ƥ뤿ʤɤ˻ѤǤǤ礦

   ΥѥåǤϰʲ󷿤ܿȤƥޤ

   enum COLORS {
     BLACK     = 0, DARKGRAY     =  8,
     BLUE      = 1, LIGHTBLUE    =  9,
     GREEN     = 2, LIGHTGREEN   = 10,
     CYAN      = 3, LIGHTCYAN    = 11,
     RED       = 4, LIGHTRED     = 12,
     MAGENTA   = 5, LIGHTMAGENTA = 13,
     BROWN     = 6, YELLOW       = 14,
     LIGHTGRAY = 7, WHITE        = 15,
   };

   顼Υ롼ˤϰʲδؿѰդƤޤ

   RGBľǡ
   coloring(ֹ, λֹ)

   2ľǡ
   coloring2(ֹ, λֹ, ܿ1, ܿ2)

   3ʿ̥ǡ
   coloring3(ֹ, λֹ, ܿ1, ܿ2, ܿ3)

   Nǡ
   coloringN(ֹ, λֹ, ܿ, *ܿ)

   ֹȽλֹϥѥåֹǤꡢ0  getmaxcolor() ֤
   顼ϰǻǤޤܿˤ COLORS ꤷޤ
   ϡ⥫顼󥰤Ԥ줿֤ޤ
   顼󥰤˼Ԥˤ 0 ֤ޤ
   ѥåȤγֹȽλֹ椬ƱǤäƤϤʤޤ

   顼Υ롼ˤä줿顼ꤹˤϡ
   ľܡѥåֹꤹʳˡ
   ưˤ벾Ūʥ顼ꤷ
   ưˤäƥ뤿δؿѰդƤޤ

   ľǡ
   co_coloring(ֹ, λֹ, double r1, double r2)
   int getcolor_(double r)
   setcolor_(double r)

   ľǡѡ줬 10 Υ
   co_coloring(ֹ, λֹ, double r1, double r2)
   int getlog10color_(double r)
   setlog10color_(double r)

   () BGI ǤϢ³ѥåֹ˴꿧ƤƤꡢ
   BLACK, BLUE, GREEN,... Ȥۿ enum  COLORS Ƥ롣
   ΥإåեŪϥѥåȤ RGB ͤľߤοɽ
   ԤȤǤΤ enum  COLORS Ƥ BLUE, RED 
   ɤ̣ͤʤʤʤ롣ʿطʿ˴ؤƤϥ
   åԤʤΤǤꥸʥ BGI Ǥϼ 16 
   ߷פƤ뤬⡼ɤˤäƤ 2,4,8 ʤɤο
   򰷤Ȥ⤢롣ޤۺ X11  BGI ǤǤտΥѥåȤ򰷤
   ȤǽǤ롣XBGI Ǥ BGI ΥѥåδȤơѥ
   ֹ 0 ˹ѥåֹ getmaxcolor() 򤬳ƤƤ롣
   δȤθȡ嵭δؿο侩ŪʻȤ, 0 
    getmaxcolor() Ϣ³ѥåֹФRGBԤ
   ȤǤ롣

   () coloring(1, getmaxcolor()-1);

   ⤷ 16 ⡼ɤʤ 1  15 ޤǤ桼Ѥ륰ǡ
   Ȥʤ 0(=BLACK)  getmaxcolor(=WHITE) ¸롣
 */

enum coloring_kinds {
  COLORING_CMY, /*0.5*/
  COLORING_MRYWGCB,
  /*COLORING_RGB,*/
  COLORING_RGB, /*0.7*/
  /*COLORING_RGBK,*/ /*0.8*/
  COLORING_RGBK, /*0.9*/
  /*COLORING_RGBW,*/ /*0.9*/
  COLORING_RYGCB,
  /*COLORING_RYGCB,*/ /*0.9*/
  COLORING_RYGCBK,
  COLORING_RYGCBM,
  /*COLORING_RYGCMB,*/ /*-1*/
  /*COLORING_RYGCMB,*/
  /*COLORING_RYGKCBM,*/
  COLORING_WMRYGCBK,
  /*COLORING_WRGB,*/
  /*COLORING_WRGB,*/ /*0.8*/
  COLORING_WRGB, /*0.9*/
  COLORING_WRYGCBK,
  COLORING_WYGCBMRK,
  COLORING_YMC, /*0.5*/
  COLORING_YRMKBCG,
  N_COLORING,
};
extern char *coloring_kind_name[];

struct coloringtype_ {
  int p1, p2;
  double r1, r2;
  enum coloring_kinds coloringkind;
};

/*
   [̾]
   coloring2c --- 2ľǡ
   coloring3c --- 3ľǡ
   coloring4c --- 4ľǡ
   coloring5c --- 5ľǡ
   coloring6c --- 6ľǡ
   coloring7c --- 7ľǡ
   coloring8c --- 8ľǡ

   []
   coloring2c(p1, p2, c1, c2, c)
   coloring3c(p1, p2, c1, c2, c3, c)
   coloring4c(p1, p2, c1, c2, c3, c4, c)
   coloring5c(p1, p2, c1, c2, c3, c4, c5, c)
   coloring6c(p1, p2, c1, c2, c3, c4, c5, c6, c)
   coloring7c(p1, p2, c1, c2, c3, c4, c5, c6, c7, c)
   coloring8c(p1, p2, c1, c2, c3, c4, c5, c6, c7, c8, c)
   int p1, p2;     ѥåֹp1p2ޤ
   int c1, c2; 2δܿ
   int c1, c2, c3; 3δܿ
   int c1, c2, c3, c4; 4δܿ
   int c1, c2, c3, c4, c5; 5δܿ
   int c1, c2, c3, c4, c5, c6; 6δܿ
   int c1, c2, c3, c4, c5, c6, c7; 7δܿ
   int c1, c2, c3, c4, c5, c6, c7, c8; 8δܿ
   double c;       Ψ

   []
   ꤵ줿N(=3)ܤȤơ
   c1 -> c2 -> c3 -> ... Ȥʤ褦ʥǡ󥫥顼ޤ
   c ϺΨ礭Ф褯ޤ
   c ο侩ͤN=3ΤȤ0.7|0.5N=4ΤȤ0.9N=5..8ΤȤ1Ǥ
 */
extern int coloring2c(int p1, int p2, int c1, int c2, double c);
extern int coloring3c(int p1, int p2, int c1, int c2, int c3, double c);
extern int coloring4c(int p1, int p2, int c1, int c2, int c3, int c4, double c);
extern int coloring5c(int p1, int p2, int c1, int c2, int c3, int c4, int c5, double c);
extern int coloring6c(int p1, int p2, int c1, int c2, int c3, int c4, int c5, int c6, double c);
extern int coloring7c(int p1, int p2, int c1, int c2, int c3, int c4, int c5, int c6, int c7, double c);
extern int coloring8c(int p1, int p2, int c1, int c2, int c3, int c4, int c5, int c6, int c7, int c8, double c);

/*
   [̾]
   coloring --- RGBľǡ

   []
   coloring(p1, p2)
   int p1, p2; ѥåֹp1p2ޤ

   []
   RGB(֡С)ܤȤơ
    ->  ->  Ȥʤ褦ʥǡ󥫥顼ޤ

   setcoloringtype(kind)
   int kind;

   enum coloring_kindsꤹ뤳Ȥˤꡢ
   ޤޤʥǡ󥫥顼ΥХꥨ٤ޤ
 */
extern void setcoloringtype(int kind);
extern int coloring(int p1, int p2);

/*
   [̾]
   coloring2 --- 2ľǡ

   []
   coloring2(p1, p2, c1, c2)
   int p1, p2; ѥåֹp1p2ޤ
   int c1, c2; 2δܿ
 *
   []
   ꤵ줿2ܤȤľΥǡޤ
 */
extern int coloring2(int p1, int p2, int c1, int c2);

/*
   [̾]
   co_coloring     --- ¿ľǡΥѥåֹб
   getcolor_       --- ꤵ줿¿бѥåȤ֤
   setcolor_       --- ꤵ줿¿бѥåȤʿ򥻥å
   getlog10color_  --- ꤵ줿¿бѥåȤ֤(п)
   setlog10color_  --- ꤵ줿¿бѥåȤʿ򥻥å(п)

   []
   co_coloring(int p1, int p2, double r1, double r2)
   int getcolor_(double r)
   setcolor_(double r)
   int getlog10color_(double r)
   setlog10color_(double r)
   int p1, p2;    ѥåֹp1p2ޤ
   double r1, r2; б¿ΰr1r2ޤ
   double r;      ¿ΰΤ

   []
   ϡ¿ľǡΥѥåֹ˥뤿
   Ѥޤ㤨СʲΤ褦˻Ѥޤ

   coloring(0, getmaxcolor());              RGBǡ
   co_coloring(0, getmaxcolor(), 0.0, 1.0); 顼¿[0,1]˼
   c = getcolor_(0.1);                      0.1бѥåȤ
   putpixel(100, 100, c);                   ɸ(100,100)
   setcolor_(0.5);                          0.5бѥåȤʿ
   line(100, 100, 200, 200);                ο

   ޤп󥰤ξϰʲΤ褦ˤޤ

   coloring(0, getmaxcolor());              RGBǡ
   co_coloring(0, getmaxcolor(), 0.001, 10.0); 顼¿[0.001,10.0]˼
   c = getlog10color_(1.0);                 1.0бѥåȤ
   putpixel(100, 100, c);                   ɸ(100,100)
   setlog10color_(0.5);                     0.5бѥåȤʿ
   line(100, 100, 200, 200);                ο

 */
extern void co_coloring(int p1, int p2, double r1, double r2);
extern int getcolor_(double r);
extern void setcolor_(double r);

extern int getlog10color_(double r);
extern void setlog10color_(double r);

/*
   [̾]
   coloring3 --- 3ʿ̥ǡ

   []
   coloring3(p1, p2, c1, c2, c3)
   int p1, p2;     ѥåֹp1p2ޤ
   int c1, c2, c3; 3δܿ

   []
   ꤵ줿3ܤȤʿ̤Υǡޤ
 */
extern int coloring3(int p1, int p2, int c1, int c2, int c3);

/*
   [̾]
   coloringN --- Nǡ

   []
   coloringN(p1, p2, n, C)
   int p1, p2; ѥåֹp1p2ޤ
   int n;      ܿο
   int *C;     ܿ

   []
   ꤵ줿NܤȤƶΥǡޤ
 */
extern int coloringN(int p1, int p2, int n, int *C);

/*
   [̾]
   swap_colors --- 2p1p2ؤ롼

   []
   swap_colors(p1, p2)
   int p1; ѥåֹ1
   int p2; ѥåֹ2

   []
   2p1p2ؤޤ
 */
extern void swap_colors(int p1, int p2);

/*
   [̾]
   rotate_colors --- p2-p1֤ΥѥåȤž롼

   []
   rotate_colors(p1, p2)
   int p1; ѥåֹ1
   int p2; ѥåֹ2

   []
   p2-p1֤ΥѥåȤžޤ
 */
extern void rotate_colors(int p1, int p2);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _COLORING_H_ */



